Foreman - Bug #23415

Clear taxable_taxonomies created by audit records on taxonomy deletion
04/27/2018 06:57 AM - Kavita Gaikwad

Status: Closed
Priority: Normal
Assignee: Kavita Gaikwad
Category:
Target version: 1.18.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/5502,
https://github.com/theforeman/foreman/p
ull/5505
Description
Description:
Error:

Katello::OrganizationTestDelete#test_org_being_deleted:

ActiveRecord::InvalidForeignKey: PG::ForeignKeyViolation: ERROR: update or delete on table "taxonomies" violates foreign key
constraint "taxable_taxonomies_taxonomy_id_fk" on table "taxable_taxonomies"

DETAIL: Key (id)=(61304186) is still referenced from table "taxable_taxonomies".

: DELETE FROM "taxonomies" WHERE "taxonomies"."type" IN ('Organization’) AND "taxonomies"."id" = $1

foreman-tasks (0.13.0) app/models/foreman_tasks/concerns/action_triggering.rb:35:in “block in destroy'

foreman-tasks (0.13.0) app/models/foreman_tasks/concerns/action_triggering.rb:121:in “dynflow_task_wrap'

foreman-tasks (0.13.0) app/models/foreman_tasks/concerns/action_triggering.rb:35:in “destroy’
/var/lib/workspace/workspace/katello-pr-test/app/models/katello/concerns/organization_extensions.rb:114:in “destroy!'
/var/lib/workspace/workspace/katello-pr-test/test/models/organization_test.rb:15:in “test_org_being_deleted'

Explanation on above error:

- For many resources, we have added audited which covers all CURD actions.

- Though we already added taxable_taxonomies :dependent => :destroy, when we try to destroy any taxonomy, it tries to destroy all
dependent resources.

And which leads to many more audit records.

- These audit records creation occured after the deletion of existing taxable_taxonomies by :dependent => :destroy.

- For these audit records, taxable_taxonomies records get created which needs to be clear before taxonomy destroy.

Related issues:
Blocks Katello - Feature #22690: [Audit] Add audit to more Katello resources... Closed 02/26/2018

Associated revisions

Revision 3a7c816a - 04/27/2018 12:45 PM - Kavita Gaikwad
Fixes #23415 - nullify taxonomy associations for audits (#5502)
On taxonomy destroy, nullify taxonomy associations for audit

records that are created by 'destroy' action on dependent
resources.

History

#1 - 04/27/2018 06:58 AM - Kavita Gaikwad

- Related to Feature #22690: [Audit] Add audit to more Katello resources - Content-view, Repository, Lifecycle environment and their associations
added

#2 - 04/27/2018 07:00 AM - Kavita Gaikwad

- Related to deleted (Feature #22690: [Audit] Add audit to more Katello resources - Content-view, Repository, Lifecycle environment and their
associations)
#3 - 04/27/2018 07:02 AM - Kavita Gaikwad

- Blocks Feature #22690: [Audit] Add audit to more Katello resources - Content-view, Repository, Lifecycle environment and their associations added

#4 - 04/27/2018 07:51 AM - The Foreman Bot
- Status changed from New to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/5502 added

#5 - 04/27/2018 12:46 PM - Marek Hulan

- translation missing: en.field_release set to 330

setting the 1.18 as this is required so other plugins can use the feature from 1.18, please let me know if there is a concern, but the patch is extremely
safe to cherry-pick

#6 - 04/27/2018 12:49 PM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/5505 added

#7 - 04/27/2018 01:02 PM - Kavita Gaikwad
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 3a7c816a77980f2f964eb8d407254a48e988c698.
